﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Audio;
using UnityEngine.UI;

public class BossAI : MonoBehaviour
{
    public AudioSource boss_hurt;
    //Set the boss Health

    public int _health = 1000;

    //Set the player as an enemy
    private GameObject _player;

    private enum _bossState { fire1, fire2, apocalypse };
    private _bossState _state = _bossState.fire1;

    public bool _standStill = false;
    private float _attackTime = 0;

    public GameObject _fireBallPrefab;
    public GameObject _RepairItem;


    private void Start()
    {
        
        _player = GameObject.FindGameObjectWithTag("Player");
    }

    private void Update()
    {
        if (!_standStill)
        {
            BossAttack();
        }
        //SetState();
        CheckDeath();
    }

    private void FixedUpdate()
    {
        //ChasePlayer();

    }

    private void SetState()
    {
        if (_health <= 75)
        {
            _state = _bossState.fire2;
        }

    }



    private void BossAttack()
    {
        if (_state == _bossState.fire1)
        {
            _standStill = true;
            StartCoroutine(Attack1());
        }

        if (_state == _bossState.fire2)
        {
            _standStill = true;
            StartCoroutine(Attack2());
        }

    }


    private void BossAttack1()
    {

        this.transform.position = Vector2.Lerp(this.transform.position, GetRandomPos(), 100f * Time.deltaTime);

    }

    private void BossAttack2()
    {
        for (int i = 0; i < 50; i++)
        {
            GameObject _go = GameObject.Instantiate(_fireBallPrefab, new Vector3(this.transform.position.x + i / 10, this.transform.position.y + i / 10), Quaternion.identity);
            _go.GetComponent<Rigidbody2D>().angularVelocity = 15 * Time.deltaTime;
        }
    }

    private Vector2 GetRandomPos()
    {
        
        Vector2 _randomPos = new Vector2(Random.Range(_player.transform.position.x - 10, _player.transform.position.x + 10), Random.Range(_player.transform.position.y + 5, _player.transform.position.y - 5));
        return _randomPos;
    }

    private IEnumerator Attack1()
    {
        BossAttack1();
        yield return new WaitForSeconds(2);

        _standStill = false;
    }

    private IEnumerator Attack2()
    {
        BossAttack2();
        yield return new WaitForSeconds(2);
        BossAttack1();
        _standStill = false;
    }

    private void CheckDeath()
    {
        if (_health <= 0)
        {
            GameObject.Instantiate(_RepairItem, this.transform.position, Quaternion.identity);
            Destroy(this.gameObject);
            GameObject.FindGameObjectWithTag("GameController").GetComponent<GameManager>().BossDied();
        }
    }
}





