﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BossAIRework : MonoBehaviour
{
    [SerializeField]
    private GameManager _gm;

    [SerializeField]
    private GameObject _player;

    private float _health = 1000;


    private enum bossStates { attack,attack2};

    private bossStates _bossState = bossStates.attack;


    public GameObject _fireBall;

    public bool standStill = false;
    public bool canShoot = false;


    private void Start()
    {
        _player = GameObject.FindGameObjectWithTag("Player");
        _gm = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameManager>();
    }

    private void Update()
    {
        if (!standStill)
        {
            MoveToPlayer();
        }
    }


    private void MoveToPlayer()
    {
        Vector2 _targetPos = _player.transform.position;
        BossAttackFireBall();
    }



    private void PrimaryBossAttack()
    {
        for (int i = 0; i < 10; i++)
        {
            if (canShoot)
            {
                GameObject _go = Instantiate(_fireBall, this.transform.position, Quaternion.identity);
                canShoot = false;
                Wait();
            }
        }
    }


    private IEnumerator BossAttackFireBall()
    {
        standStill = true;
        PrimaryBossAttack();
        yield return new WaitForSeconds(3);
        standStill = false;
    }

    private IEnumerator Wait()
    {
        yield return new WaitForSeconds(5);
        canShoot = true;
    }

}
