﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Audio;
using UnityEngine.UI;


public class EnemyAI : MonoBehaviour
{
    public AudioSource hurt;
    //Get GameManager
    [SerializeField]
    private GameManager _gm;

    public GameObject _goldCoinPrefab;

    //Get the player enemy
    public GameObject _enemy;

    //Current Health
    public int currentHealth = 100;

    //Deal Damage
    private float _timeToDamage = 0;

    //[SerializeField]
    //private ShowNearestEnemy _shNearestEnemy;

    private void Start()
    {
        _enemy = GameObject.FindGameObjectWithTag("Player");
        _gm = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameManager>();
    }

    private void Update()
    {
        CheckIfAlive();
        FlipSides();
        if (_enemy != null)
        {
            Attack();
        }
    }

    private void FixedUpdate()
    {
        if (_enemy != null)
        {
            this.transform.position = Vector2.Lerp(this.transform.position, new Vector2(_enemy.transform.position.x+2,_enemy.transform.position.y), Time.deltaTime);
            GetComponent<Animator>().SetBool("isWalking", true);
        }
    }

    private void FlipSides()
    {
        if (Input.GetAxis("Horizontal") > 0 )
        {
            GetComponent<SpriteRenderer>().flipX = true;
        }
        else if(Input.GetAxis("Horizontal") < 0) { GetComponent<SpriteRenderer>().flipX = false; }
    }

    public void CheckIfAlive()
    {
        if (currentHealth <= 0)
        {
            _gm.EnemyKilled();
            GameObject _coin = GameObject.Instantiate(_goldCoinPrefab, this.transform.position, Quaternion.identity);
            //_shNearestEnemy._isPointing = false;
            Destroy(this.gameObject);
        }
    }

    private void Attack()
    {
        
        if (Vector2.Distance(this.transform.position, _enemy.transform.position) <=2f)
        {
            GetComponent<Animator>().SetTrigger("Attack");
            if (Time.time >= _timeToDamage)
            {
                _enemy.GetComponent<Animator>().SetTrigger("takeDamage");
                _enemy.GetComponent<PlayerController>()._currentHealth -= 25;
                _timeToDamage = Time.time + 1.5f;

                //hurt = GetComponent<AudioSource>();
                //hurt.Play();

               
            }
        }

        
    }

    
}
