﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class HeartManager : MonoBehaviour
{
    [SerializeField]
    private PlayerController _playerController;

    [SerializeField]
    private GameObject[] _heart;

    [SerializeField]
    private Sprite _emptyHeart;
    [SerializeField] 
    private Sprite _filledHeart;

    public int _upgrades = 0;

    private int _currentHeart = 3;

    public int _maxHealth;

    

    private void Update()
    {
        _maxHealth = _playerController._maxHealth;
        HealthUpdate();
    }

    private void HealthUpdate()
    {
        if (_playerController._currentHealth == _maxHealth)
        {
            foreach (var i in _heart)
            {
                i.GetComponent<Image>().sprite = _filledHeart;
            }
        }

        if (_playerController._currentHealth == _maxHealth - 25)
        {
            _heart[2 + _upgrades].GetComponent<Image>().sprite = _emptyHeart;
        }

        if (_playerController._currentHealth == _maxHealth - 50)
        {
            _heart[2 + _upgrades - 1].GetComponent<Image>().sprite = _emptyHeart;
        }

        if (_playerController._currentHealth == _maxHealth - 75)
        {
            _heart[_upgrades].GetComponent<Image>().sprite = _emptyHeart;
        }

    }
}
