﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ShowNearestEnemy : MonoBehaviour
{
    private GameObject[] _allEnemies;
    private GameObject _target;

    [SerializeField]
    private GameObject _player;

    float lowestDistance = 1000;

    public bool _isPointing = false;

    private void Update()
    {
        
        _allEnemies = GameObject.FindGameObjectsWithTag("Enemy");

        if (!_isPointing)
        {
            PointAtNearestEnemy();
        }
        
    }

    

    private void PointAtNearestEnemy()
    {
        int i = Random.Range(0, _allEnemies.Length);
        _target = _allEnemies[i];


        Vector2 _direction = (_target.transform.position - this.transform.position).normalized;
        Quaternion _lookRot = Quaternion.LookRotation(_direction);

        this.transform.rotation = Quaternion.Slerp(transform.rotation, _lookRot, Time.deltaTime * 1.5f);
        transform.eulerAngles = new Vector3(0, 0, transform.eulerAngles.z);
        _isPointing = true;
        

    }
}
