﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Audio;


public class SpikeMove : MonoBehaviour
{
    public AudioSource source;

    //Get waypoints
    public GameObject[] waypoints;

    //Current waypoint
    public int currentWaypoint = 0;

    private bool _checkpointReached = false;

    private void FixedUpdate()
    {
        LerpSpikes();
    }

    private void LerpSpikes()
    {
        this.transform.position = Vector2.Lerp(this.transform.position, waypoints[currentWaypoint].transform.position, 3f*Time.deltaTime);
        if (Vector2.Distance(this.transform.position, waypoints[currentWaypoint].transform.position) <= 1.2f)
        {
            _checkpointReached = true;
        }
        else { _checkpointReached = false; }

        if (_checkpointReached)
        {
            currentWaypoint++;
            if (currentWaypoint > 1)
            {
                currentWaypoint = 0;
            }
        }
    }
    private void OnTriggerEnter2D(Collider2D collision)
    {
        if (collision.CompareTag("Player"))
        {
            collision.GetComponent<PlayerController>()._currentHealth -= 25;
        }
    }
}
